{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.9 for Windows and Linux
Author Sergey Vladimirovich Bulba
(c)1999-2016 S.V.Bulba
}

unit seldir;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  EditBtn, StdCtrls;

type

  { TSelDirDlg }

  TSelDirDlg = class(TForm)
    Button1: TButton;
    Button2: TButton;
    RecurseChk: TCheckBox;
    DoDetect: TCheckBox;
    DirEdit: TDirectoryEdit;
  private
    { private declarations }
  public
    { public declarations }
  end;

function ChooseDirectory(var Dir:string;const Capt:string;Extra:boolean;const s1,s2:string;v1,v2:PBoolean):boolean;

var
  SelDirDlg: TSelDirDlg;

implementation

{$R *.lfm}

function ChooseDirectory(var Dir:string;const Capt:string;Extra:boolean;const s1,s2:string;v1,v2:PBoolean):boolean;
begin
Result := False;
SelDirDlg.DirEdit.Directory:=Dir;
SelDirDlg.DirEdit.DialogTitle:=Capt;
SelDirDlg.Caption:=Capt;
SelDirDlg.RecurseChk.Visible:=Extra;
SelDirDlg.DoDetect.Visible:=Extra;
if Extra then
 begin
  SelDirDlg.RecurseChk.Checked := v1^;
  SelDirDlg.DoDetect.Checked := v2^;
  SelDirDlg.RecurseChk.Caption := s1;
  SelDirDlg.DoDetect.Caption := s2;
 end;
if SelDirDlg.ShowModal = mrOk then
 begin
  if Extra then
   begin
    v1^ := SelDirDlg.RecurseChk.Checked;
    v2^ := SelDirDlg.DoDetect.Checked;
   end;
  Dir := SelDirDlg.DirEdit.Directory;
  Result := True;
 end;
end;

end.

