{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.9 for Windows and Linux
Author Sergey Vladimirovich Bulba
(c)1999-2016 S.V.Bulba
}

program Ay_Emul;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, // this includes the LCL widgetset
  LCLIntf, SysUtils, Forms, Dialogs,
  {$IFDEF Windows}
  WaveOutAPI, Midi, CDviaMCI, SelectCDs, lighttlhelp32,
  {$ENDIF Windows}
  BASScode, lightBASS, BassTags, About, MainWin, LH5, HeadEdit, Mixer, PlayList,
  ProgBox, ItemEdit, Tools, Z80, JmpTime, Players, AY, Convs, UniReader,
  Languages, FindPLItem, digidrum, WinVersion, Options, SelVolCtrl,
  seldir;

{$R *.res}

begin
OnShowException := @Ay_Emul_ShowException;
{$IFNDEF Windows}
IsConsole := False; //temporary for show exceptions in messagebox instead of linux console
{$ENDIF Windows}

{$IFDEF Windows}
if not ProcessExists then
{$ENDIF Windows}
 begin
  {$IFDEF Windows}
  StartDDE;
  {$ENDIF Windows}
  Application.Initialize;
  Application.CreateForm(TForm1, Form1);
  Application.OnException:=@Form1.Ay_Emul_ShowExceptionA;
  Application.CreateForm(TForm2, Form2);
  Application.CreateForm(TForm3, Form3);
  Application.CreateForm(TSelDirDlg, SelDirDlg);
  {$IFDEF Windows}
  Application.CreateForm(TCDList, CDList);
  Form1.Visible := False; //does not work in GTK2 properly (strange behaviour)
  {$ENDIF Windows}
  try
   Form1.CommandLineAndRegCheck;
  except
   ShowException(ExceptObject, ExceptAddr);
  end;
  {$IFDEF Windows}
  Form1.Visible := True; //does not work in GTK2 properly (strange behaviour)
  {$ENDIF Windows}
  Application.Run;
  {$IFDEF Windows}
  StopDDE;
  {$ENDIF Windows}
 end;
end.
