{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.9 for Windows and Linux
Author Sergey Vladimirovich Bulba
(c)1999-2016 S.V.Bulba
}

unit Languages;

{$mode objfpc}{$H+}

interface

const
 Def_InvalidLZH = 'LZH compressed data is not valid';
 Mes_InvalidLZH:string = Def_InvalidLZH;
 Def_ReadAfterEndOfFile = 'Read after end of file';
 Mes_ReadAfterEndOfFile:string = Def_ReadAfterEndOfFile;
 Def_SeekAfterEndOfFile = 'Seek after end of file';
 Mes_SeekAfterEndOfFile:string = Def_SeekAfterEndOfFile;
 Def_ReadAfterEndOfData = 'Read after end of data';
 Mes_ReadAfterEndOfData:string = Def_ReadAfterEndOfData;
 Def_FileSeekError = 'FileSeek error';
 Mes_FileSeekError:string = Def_FileSeekError;
 Def_FileOpenError = 'FileOpen error';
 Mes_FileOpenError:string = Def_FileOpenError;
 Def_FileReadError = 'FileRead error';
 Mes_FileReadError:string = Def_FileReadError;

 //Multilanguage supporting
 Lan_Mixer_BoxTitle  :string = 'Микшер';
 Lan_Mixer_Resampler :string = 'Передискретизация';
 Lan_Mixer_Averager  :string = 'усреднение';
 Lan_Mixer_FIRFilter :string = 'FIR-фильтр';
 Lan_Mixer_FstInt    :string = 'Смещение прерывания';
 Lan_Mixer_ChansAmpl :string = 'Усиление каналов';
 Lan_Mixer_FrqAY     :string = 'Частота микросхемы';
 Lan_Mixer_ChType    :string = 'Тип микросхемы';
 Lan_Mixer_SamRate   :string = 'Частота сэмплов';
 Lan_Mixer_BitRate   :string = 'Бит на сэмпл';
 Lan_Mixer_FrqPlr    :string = 'Частота прерываний';
 Lan_Mixer_Chans     :string = 'Каналы';
 Lan_Mixer_Restore   :string = 'Восстановить';
 Lan_Mixer_Get       :string = 'Брать из списка';
 Lan_Mixer_Another   :string = 'Другая';
 Lan_Mixer_FrqZ80    :string = 'Частота Z80';
 Lan_Mixer_Close     :string = 'Закрыть';

 Lan_Tools_BoxTitle_En  :string = 'Tools';
 Lan_Tools_BoxTitle_Ru  :string = 'Инструменты';
 Lan_Tools_ConvParam_En :string = 'Other';
 Lan_Tools_ConvParam_Ru :string = 'Прочее';
 Lan_Tools_Searching_En :string = 'Searching for tunes in files';
 Lan_Tools_Searching_Ru :string = 'Поиск модулей в файлах';
 Lan_Tools_Prior_En     :string = 'Priority';
 Lan_Tools_Prior_Ru     :string = 'Приоритет';
 Lan_Tools_StartMenu_En :string = '''Start'' menu';
 Lan_Tools_StartMenu_Ru :string = 'Меню "Пуск"';
 Lan_Tools_SourceFls_En :string = 'Source files:';
 Lan_Tools_SourceFls_Ru :string = 'Исходные файлы:';
 Lan_Tools_WorkFold_En  :string = 'Work folder:';
 Lan_Tools_WorkFold_Ru  :string = 'Рабочая папка:';
 Lan_Tools_Choose_En    :string = 'Choose...';
 Lan_Tools_Choose_Ru    :string = 'Обзор...';
 Lan_Tools_SearchFor_En :string = 'Search for tunes';
 Lan_Tools_SearchFor_Ru :string = 'Искать модули';
 Lan_Tools_WorkRep_En   :string = 'Work report:';
 Lan_Tools_WorkRep_Ru   :string = 'Протокол работы:';
 Lan_Tools_Begin_En     :string = 'Begin';
 Lan_Tools_Begin_Ru     :string = 'Начать';
 Lan_Tools_Stop_En      :string = 'Stop';
 Lan_Tools_Stop_Ru      :string = 'Стоп';
 Lan_Tools_Rereg_En     :string = 'Reregister';
 Lan_Tools_Rereg_Ru     :string = 'Перерегистрировать';
 Lan_Tools_Apply_En     :string = 'Apply';
 Lan_Tools_Apply_Ru     :string = 'Применить';
 Lan_Tools_Save_En      :string = 'Save';
 Lan_Tools_Save_Ru      :string = 'Сохранить';
 Lan_Tools_FilesReg_En  :string = 'Files registration (administrator only)';
 Lan_Tools_FilesReg_Ru  :string = 'Регистрация файлов (только администратор)';
 Lan_Tools_RemoveEmu_En :string = 'Uninstall';
 Lan_Tools_RemoveEmu_Ru :string = 'Деинсталлировать';
 Lan_Tools_Restore_En   :string = 'Restore';
 Lan_Tools_Restore_Ru   :string = 'Восстановить';
 Lan_Tools_Idle_En      :string = 'idle';
 Lan_Tools_Idle_Ru      :string = 'низкий';
 Lan_Tools_Normal_En    :string = 'normal';
 Lan_Tools_Normal_Ru    :string = 'обычный';
 Lan_Tools_High_En      :string = 'high';
 Lan_Tools_High_Ru      :string = 'высокий';
 Lan_Tools_Remove_En    :string = 'Remove';
 Lan_Tools_Remove_Ru    :string = 'Убрать';
 Lan_Tools_Add_En       :string = 'Add';
 Lan_Tools_Add_Ru       :string = 'Добавить';
 Lan_Tools_Tray_En      :string = 'Icon on system tray';
 Lan_Tools_Tray_Ru      :string = 'Значок на панели задач';
 Lan_Tools_Always_En    :string = 'always';
 Lan_Tools_Always_Ru    :string = 'всегда';
 Lan_Tools_Never_En     :string = 'never';
 Lan_Tools_Never_Ru     :string = 'никогда';
 Lan_Tools_Minim_En     :string = 'minimize';
 Lan_Tools_Minim_Ru     :string = 'сворачивать';
 Lan_Tools_SkAut_En     :string = 'Skin''s author';
 Lan_Tools_SkAut_Ru     :string = 'Автор обшивки';
 Lan_Tools_SkCom_En     :string = 'Comment';
 Lan_Tools_SkCom_Ru     :string = 'Комментарий';
 Lan_Tools_SkFN_En      :string = 'File name';
 Lan_Tools_SkFN_Ru      :string = 'Имя файла';
 Lan_Tools_SkStd_En     :string = 'Standard';
 Lan_Tools_SkStd_Ru     :string = 'Стандарт';
 Lan_Tools_SkTit_En     :string = 'Current Skin';
 Lan_Tools_SkTit_Ru     :string = 'Текущая обшивка';
 Lan_Tools_AutoSave_En  :string = 'Automatically save current';
 Lan_Tools_AutoSave_Ru  :string = 'Автоматически запоминать текущую';
 Lan_Tools_DefDir_En    :string = 'Folder with music';
 Lan_Tools_DefDir_Ru    :string = 'Папка с музыкой';

 Lan_List_BoxTitle   :string = 'Список проигрывания';
 Lan_List_AddItems   :string = 'Добавить';
 Lan_List_ClearList  :string = 'Очистить';
 Lan_List_SaveList   :string = 'Сохранить';
 Lan_List_Tools      :string = 'Действия';
 Lan_List_ItemAdj    :string = 'Настройка элемента...';
 Lan_List_Convert    :string = 'Конвертировать в';
 Lan_List_SaveItem   :string = 'Сохранить как...';
 Lan_List_OpenInEditor:string = 'Открыть в редакторе';

implementation

end.
