{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.9 for Windows and Linux
Author Sergey Vladimirovich Bulba
(c)1999-2016 S.V.Bulba
}

unit Tools;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf, {$IFDEF Windows}Windows, ShlObj, ComObj, ActiveX, {$ENDIF Windows}
  SysUtils, FileUtil, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons, WinVersion, LConvEncoding;

const
 NOfIcons = 16;
 IconAuthors:array[0..NOfIcons] of string =
 ('Sergey Bulba','X-agon','X-agon','X-agon','X-agon','David Willis',
  'Graham Goring','Graham Goring','Graham Goring','Graham Goring',
  'bcass','bcass','Exocet','Exocet','Roman Morozov','Ivan Reshetnikov',
  'Ivan Reshetnikov');

type
    TSelIconProc = procedure(n:integer) of object;
    TIconSelector = class
    IcGrp:TGroupBox;
    IcImg:TImage;
    IconUpDown:TUpDown;
    AuthLB,AuthName:TLabel;
    constructor Create(AOwner:TWinControl);
    destructor Destroy; override;
    procedure ShowIcon;
    procedure IconUpDownClick(Sender: TObject; Button: TUDBtnType);
    public
    DoSelectIcon:TSelIconProc;
    end;

    { TForm6 }

    TForm6 = class(TForm)
    CBDefCP: TComboBox;
    Edit9: TEdit;
    GroupBox7: TGroupBox;
    Label20: TLabel;
    PageControl1: TPageControl;
    GenTools: TTabSheet;
    GroupBox1: TGroupBox;
    CheckBox40: TCheckBox;
    GroupBox5: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox6: TGroupBox;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    GroupBox10: TGroupBox;
    Button10: TButton;
    Button11: TButton;
    GroupBox11: TGroupBox;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    GroupBox12: TGroupBox;
    Label8: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit3: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Button12: TButton;
    Button13: TButton;
    GroupBox13: TGroupBox;
    Edit4: TEdit;
    CheckBox38: TCheckBox;
    Button14: TButton;
    FTypTools: TTabSheet;
    SearchTool: TTabSheet;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    DName: TEdit;
    GroupBox3: TGroupBox;
    CheckBox9: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox33: TCheckBox;
    Protokol: TMemo;
    ProgressBar1: TProgressBar;
    Button3: TButton;
    Memo1: TMemo;
    Button8: TButton;
    Button9: TButton;
    FIDOTools: TTabSheet;
    Label2: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    CheckBox29: TCheckBox;
    CheckBox41: TCheckBox;
    CheckBox42: TCheckBox;
    CheckBox43: TCheckBox;
    Button16: TButton;
    Button4: TButton;
    Button7: TButton;
    CheckBox57: TCheckBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    ColorDialog1: TColorDialog;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    Button5: TButton;
    Button6: TButton;
    Button15: TButton;
    Button17: TButton;
    GroupBox4: TGroupBox;
    EditVTPath: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure AllEnable;
    procedure CBDefCPChange(Sender: TObject);
    function CloseQuery:boolean;override;
    procedure Button4Click(Sender: TObject);
    procedure Edit4EditingDone(Sender: TObject);
    procedure Edit9EditingDone(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
{$IFDEF Windows}
    procedure RegisterGroup(rt:boolean;t:integer;lb:TListBox;All:boolean);
{$ENDIF Windows}
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure RadioButton9Click(Sender: TObject);
    procedure RadioButton10Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure CheckBox38Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox40Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure SelectMenuIcon(n:integer);
    procedure SelectMusIcon(n:integer);
    procedure SelectSkinIcon(n:integer);
    procedure SelectListIcon(n:integer);
    procedure SelectBASSIcon(n:integer);
    procedure Label1Click(Sender: TObject);
    procedure Label12Click(Sender: TObject);
    procedure Label13Click(Sender: TObject);
    procedure Label14Click(Sender: TObject);
    procedure Label15Click(Sender: TObject);
    procedure Label16Click(Sender: TObject);
    procedure Label18Click(Sender: TObject);
    procedure Label19Click(Sender: TObject);
    procedure Label17Click(Sender: TObject);
    function ChangePLColor(var WantedColor:TColor):boolean;
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox3Click(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure CreateIcSel(IcSel:TIconSelector;AOwner:TWinControl;SelIconProc:TSelIconProc;x,y:integer;const IcName:string;IcNum:integer);
    procedure Button5Click(Sender: TObject);
    procedure EditVTPathChange(Sender: TObject);
    procedure FillTools;
  private
    { Private declarations }
  public
    { Public declarations }
    AppIcSel,TrayIcSel,StartIcSel,
    MusIcSel,SkinIcSel,ListIcSel,BASSIcSel:TIconSelector;
  end;

{$IFDEF Windows}
procedure SetPriority(Pr:longword);
{$ENDIF Windows}

var
  Form6: TForm6;
  {$IFDEF Windows}
  Priority:dword = NORMAL_PRIORITY_CLASS;
  {$ENDIF Windows}

implementation

uses
  MainWin, Mixer, Players, PlayList, Options, seldir, Languages;

{$R *.lfm}

{$IFDEF Windows}
procedure SetPriority(Pr:longword);
var
 HMyProcess:longword;
begin
HMyProcess := GetCurrentProcess;
SetPriorityClass(HMyProcess,Pr);
CloseHandle(HMyProcess);
Priority := Pr;
end;
{$ENDIF Windows}

procedure TForm6.Button2Click(Sender: TObject);
var
 s1,s2:string;
begin
if Russian_Interface then
 s1 := 'Выбор рабочей папки'
else
 s1 := 'Select folder';
if DirectoryExistsUTF8(DName.Text) then
 s2 := DName.Text
else
 s2 := Form1.OpenDialog1.InitialDir;
if ChooseDirectory(s2,s1,False,'','',nil,nil) then
 DName.Text :=
  {$IFDEF Windows}
   AnsiToUTF8(ValidateDirName(UTF8Decode(s2)));
  {$ELSE Windows}
   s2;
  {$ENDIF Windows}
end;

procedure TForm6.Button1Click(Sender: TObject);
begin
if Russian_Interface then
 Form1.OpenDialog1.Filter := 'Все файлы|*.*'
else
 Form1.OpenDialog1.Filter := 'All files|*.*';
Form1.OpenDialog1.Filter := Form1.OpenDialog1.Filter +
 '|SNA|*.sna|TRD, TD0, FDI, SCL|*.trd;*.scl;*.fdi;*.td0|BIN|*.bin|TAP, TZX|' +
 '*.tap;*.tzx';
if Form1.OpenDialog1.Execute then
 begin
  Memo1.Lines := Form1.OpenDialog1.Files;
  Form1.OpenDialog1.FileName := '';
 end;
end;

procedure TForm6.Button3Click(Sender: TObject);
begin
if FinderWorksNow then
 begin
  May_Quit := True;
  AllEnable;
 end
else
 begin
  if Russian_Interface then
   Button3.Caption := Lan_Tools_Stop_Ru
  else
   Button3.Caption := Lan_Tools_Stop_En;
  Memo1.ReadOnly := True;
  DName.ReadOnly := True;
  Button1.Enabled := False;
  Button2.Enabled := False;
  Button4.Enabled := False;
  GroupBox1.Enabled := False;
  GroupBox3.Enabled := False;
  GroupBox5.Enabled := False;
  GroupBox6.Enabled := False;
  GroupBox10.Enabled := False;
  Protokol.Clear;
  FindModules;
 end;
end;

Procedure TForm6.AllEnable;
begin
FinderWorksNow := False;
if Russian_Interface then
 Button3.Caption := Lan_Tools_Begin_Ru
else
 Button3.Caption := Lan_Tools_Begin_En;
Memo1.ReadOnly := False;
DName.ReadOnly := False;
Button1.Enabled := True;
Button2.Enabled := True;
Button4.Enabled := True;
GroupBox1.Enabled := True;
GroupBox3.Enabled := True;
GroupBox5.Enabled := True;
GroupBox6.Enabled := True;
GroupBox10.Enabled := True
end;

procedure TForm6.CBDefCPChange(Sender: TObject);
begin
CodePageDef := CBDefCP.Text;
end;

procedure TForm6.Button4Click(Sender: TObject);
begin
{$IFDEF Windows}
PostMessage(Handle,WM_CLOSE,0,0);
{$ELSE Windows}
Close;
{$ENDIF Windows}
end;

procedure TForm6.Edit4EditingDone(Sender: TObject);
var
 s:string;
begin
s := Trim(Edit4.Text);
if DirectoryExistsUTF8(s) then
 Form1.DefaultDirectory := s;
end;

procedure TForm6.Edit9EditingDone(Sender: TObject);
 var
 i:integer;
begin
try
 try
  i := StrToInt(Trim(Edit9.Text));
 except
  exit;
 end;
 Form1.SetVisTimerPeriod(i);
finally
 Edit9.Text := IntToStr(VisTimerPeriod);
end;

end;

function TForm6.CloseQuery:boolean;
begin
Result := not FinderWorksNow;
if Result then
 begin
  if ButTools.Is_On then ButTools.Switch_Off;
  ToolsY := Top;
  ToolsX := Left;
 end;
end;

procedure TForm6.RadioButton3Click(Sender: TObject);
begin
if not RadioButton3.Checked then exit;
{$IFDEF Windows}
SetPriority(IDLE_PRIORITY_CLASS);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.RadioButton4Click(Sender: TObject);
begin
if not RadioButton4.Checked then exit;
{$IFDEF Windows}
SetPriority(NORMAL_PRIORITY_CLASS);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.RadioButton5Click(Sender: TObject);
begin
if not RadioButton5.Checked then exit;
{$IFDEF Windows}
SetPriority(HIGH_PRIORITY_CLASS);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.RadioButton6Click(Sender: TObject);
begin
if RadioButton6.Checked and not Russian_Interface then
 begin
  Form1.SwapLan;
  FillTools;
 end;
end;

procedure TForm6.RadioButton7Click(Sender: TObject);
begin
if RadioButton7.Checked and Russian_Interface then
 begin
  Form1.SwapLan;
  FillTools;
 end;
end;

procedure TForm6.Button7Click(Sender: TObject);
var
 s:string;
begin
Uninstall := True;
DeleteOptions;
DeleteDefaultPL; //todo: remove config folder
s := '';
{$IFDEF Windows}
try
 Button9Click(Sender);
except
 s := ' (excepting restoring file registration data, administrator rights needed)';
end;
{$ENDIF Windows}
ShowMessage('Ay_Emul data is removed from your system'+s+'. Close the program ' +
            'and delete Ay_Emul folder to complete uninstall. See you!');
end;

{$IFDEF Windows}
procedure StartMenuLink(ChangeIcon:boolean);
var
 AnObj:IUnknown;
 ShLink:IShellLink;
 PFile:IPersistFile;
 StartMenuDir,MyProgramPath:string;
 ShCutPath:WideString;
 Pidl:PItemIDList;
 F:file;
begin
SetLength(StartMenuDir, MAX_PATH + 1);
if (SHGetSpecialFolderLocation(Form1.Handle, CSIDL_PROGRAMS,Pidl)
    = NOERROR) and SHGetPathFromIDList(Pidl, PChar(StartMenuDir)) then
 begin
  StartMenuDir := StrPas(PChar(StartMenuDir));
  ShCutPath := StartMenuDir + '\AY Emulator.lnk';
  if not SysUtils.FileExists(ShCutPath) then
   begin
    if ChangeIcon then exit;
   end
  else
   begin
    AssignFile(F,ShCutPath);
    Erase(F);
   end;
  MyProgramPath := ValidateFileName(UTF8Decode(GetProcessFileName));
  AnObj := CreateComObject(CLSID_ShellLink);
  ShLink := AnObj as IShellLink;
  PFile := AnObj as IPersistFile;
  ShLink.SetPath(PChar(MyProgramPath));
  ShLink.SetWorkingDirectory(PChar(ExtractFileDir(MyProgramPath)));
  ShLink.SetIconLocation(PChar(MyProgramPath),MenuIconNumber);
  PFile.Save(PWChar(ShCutPath), False);
 end;
end;
{$ENDIF Windows}

procedure TForm6.SelectMenuIcon(n:integer);
begin
if MenuIconNumber = n then exit;
MenuIconNumber := n;
{$IFDEF Windows}
StartMenuLink(True);
{$ENDIF Windows}
end;

procedure TForm6.Button10Click(Sender: TObject);
begin
{$IFDEF Windows}
StartMenuLink(False);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.Button11Click(Sender: TObject);
{$IFDEF Windows}
var
 Pidl:PItemIDList;
 StartMenuDir:string;
 F:file;
begin
SetLength(StartMenuDir, MAX_PATH + 1);
if (SHGetSpecialFolderLocation(Form1.Handle, CSIDL_PROGRAMS,Pidl)
    = NOERROR) and SHGetPathFromIDList(Pidl, PChar(StartMenuDir)) then
 begin
  StartMenuDir := StrPas(PChar(StartMenuDir)) + '\AY Emulator.lnk';
  if SysUtils.FileExists(StartMenuDir) then
   begin
    AssignFile(F,StartMenuDir);
    Erase(F);
   end;
 end;
{$ELSE Windows}
begin
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.RadioButton8Click(Sender: TObject);
begin
if not RadioButton8.Checked then exit;
Form1.Set_TrayMode2(0);
end;

procedure TForm6.RadioButton9Click(Sender: TObject);
begin
if not RadioButton9.Checked then exit;
Form1.Set_TrayMode2(1);
end;

procedure TForm6.RadioButton10Click(Sender: TObject);
begin
if not RadioButton10.Checked then exit;
Form1.Set_TrayMode2(2);
end;

procedure TForm6.Button12Click(Sender: TObject);
var
 tmp:integer;
 s,s1,s2:string;
begin
s := Form1.OpenDialog1.FileName;
s1 := Form1.OpenDialog1.InitialDir;
Form1.OpenDialog1.FileName := '';
tmp := Form1.OpenDialog1.FilterIndex;
Form1.OpenDialog1.FilterIndex := 1;
Form1.OpenDialog1.Options := [OfHideReadOnly,OfEnableSizing];
if Russian_Interface then
 Form1.OpenDialog1.Filter := 'Файлы шаблонов (AYS)|*.ays'
else
 Form1.OpenDialog1.Filter := 'Skin files (AYS)|*.ays';
if Form1.SkinDirectory <> '' then
 Form1.OpenDialog1.InitialDir := Form1.SkinDirectory;
if Form1.OpenDialog1.Execute then
 begin
  s2 := {ValidateFileName(UTF8Decode(}Form1.OpenDialog1.FileName;
  if Form1.LoadSkin(s2,False) then
   Form1.SkinDirectory := ExtractFileDir(s2);
 end;
Form1.OpenDialog1.InitialDir := s1;
Form1.OpenDialog1.FilterIndex := tmp;
Form1.OpenDialog1.FileName := s;
Form1.OpenDialog1.Options := [OfHideReadOnly,OfEnableSizing,OfAllowMultiSelect];
end;

procedure TForm6.Button13Click(Sender: TObject);
begin
if Form1.SkinFileName <> '' then
 Form1.LoadSkin('',False);
end;

procedure TForm6.CheckBox38Click(Sender: TObject);
begin
AutoSaveDefDir := CheckBox38.Checked;
end;

procedure TForm6.Button14Click(Sender: TObject);
begin
SaveDefaultDir3;
end;

procedure TForm6.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
CloseAction := caFree;
AppIcSel.Free;
TrayIcSel.Free;
StartIcSel.Free;
MusIcSel.Free;
SkinIcSel.Free;
ListIcSel.Free;
BASSIcSel.Free;
end;

procedure TForm6.CreateIcSel(IcSel:TIconSelector;AOwner:TWinControl;SelIconProc:TSelIconProc;x,y:integer;const IcName:string;IcNum:integer);
begin
IcSel := TIconSelector.Create(AOwner);
with IcSel do
 begin
  DoSelectIcon := SelIconProc;
  IcGrp.Top := y;
  IcGrp.Left := x;
  IcGrp.Caption := IcName;
  IconUpDown.Position := IcNum;
  ShowIcon;
 end;
end;

procedure TForm6.FormCreate(Sender: TObject);

 procedure AddExt(i:Available_Types;t:integer;lb:TListBox);
 var
  j:Available_Types;
  n:integer;
  f:boolean;
  s:string;
 begin
  f := False;
  for j := MinAYChipFile to Pred(i) do
   if SExts[i] = SExts[j] then
    begin
     f := True;
     break;
    end;
  if not f then
   begin
    s := SExts[i];
    n := lb.Items.Add(s);
    if CheckRegistration(PChar(s),t) then
     lb.Selected[n] := True;
   end;
 end;

var
 i:Available_Types;
begin
if ToolsX <> MaxInt then
 begin
  Top := ToolsY;
  Left := ToolsX;
  AdjustFormOnDesktop(Self);
 end
else
 Position := poScreenCenter;

CreateIcSel(AppIcSel,GenTools,@Form1.SelectAppIcon,213,247,'Application icon',AppIconNumber);
CreateIcSel(TrayIcSel,GenTools,@Form1.SelectTrayIcon,111,247,'Tray icon',TrayIconNumber);
CreateIcSel(StartIcSel,GenTools,@SelectMenuIcon,9,247,'''Start'' menu icon',MenuIconNumber);
CreateIcSel(MusIcSel,FTypTools,@SelectMusIcon,ListBox1.Left-104,ListBox1.Top,'Music files icon',MusIconNumber);
CreateIcSel(SkinIcSel,FTypTools,@SelectSkinIcon,ListBox4.Left-104,ListBox4.Top,'Skin files icon',SkinIconNumber);
CreateIcSel(ListIcSel,FTypTools,@SelectListIcon,ListBox3.Left-104,ListBox3.Top,'Playlists icon',ListIconNumber);
CreateIcSel(BASSIcSel,FTypTools,@SelectBASSIcon,ListBox2.Left-104,ListBox2.Top,'BASS files icon',BASSIconNumber);

ListBox1.ControlStyle := ListBox1.ControlStyle - [csDoubleClicks];
ListBox2.ControlStyle := ListBox2.ControlStyle - [csDoubleClicks];
ListBox3.ControlStyle := ListBox3.ControlStyle - [csDoubleClicks];
ListBox4.ControlStyle := ListBox4.ControlStyle - [csDoubleClicks];

{$IFDEF Windows}
try
 SetIfRegPath;
except
end;
{$ENDIF Windows}
for i := MinAYChipFile to MaxAYChipFile do
 AddExt(i,0,ListBox1);
AddExt(CDAFile,0,ListBox1);
for i := MIDFileMin to MIDFileMax do
 AddExt(i,0,ListBox1);

try
ListBox1.Selected[ListBox1.Items.Add('.MIDI')] := CheckRegistration('.midi',0);
for i := BASSFileMin to BASSFileMax do
 AddExt(i,3,ListBox2);
ListBox3.Selected[ListBox3.Items.Add('.AYL')] := CheckRegistration('.ayl',1);
ListBox3.Selected[ListBox3.Items.Add('.M3U')] := CheckRegistration('.m3u',1);
ListBox3.Selected[ListBox3.Items.Add('.M3U8')] := CheckRegistration('.m3u8',1);
ListBox3.Selected[ListBox3.Items.Add('.PLS')] := CheckRegistration('.pls',1);
ListBox3.Selected[ListBox3.Items.Add('.CUE')] := CheckRegistration('.cue',1);
ListBox4.Selected[ListBox4.Items.Add('.AYS')] := CheckRegistration('.ays',2);
except
end;

   EditVTPath.Text := VTPath;
   Edit1.Text := Form1.SkinAuthor;
   Edit2.Text := Form1.SkinComment;
   Edit3.Text := Form1.SkinFileName;
   Edit4.Text := Form1.DefaultDirectory;
   CheckBox38.Checked := AutoSaveDefDir;
   CheckBox40.Checked := AutoSaveWindowsPos;
   DName.Text := IncludeTrailingPathDelimiter(Form1.OpenDialog1.InitialDir);
   DName.Text :=
   {$IFDEF Windows}
    AnsiToUTF8(ValidateDirName(UTF8Decode(DName.Text)))
   {$ELSE Windows}
    DName.Text
   {$ENDIF Windows}
    + 'AYFinderTmp';
   {$IFDEF Windows}
   case Priority of
   IDLE_PRIORITY_CLASS:RadioButton3.Checked:=True;
   NORMAL_PRIORITY_CLASS:RadioButton4.Checked:=True;
   HIGH_PRIORITY_CLASS:RadioButton5.Checked:=True;
   end;
   {$ENDIF Windows}
   case TrayMode of
   0:RadioButton8.Checked:=True;
   1:RadioButton9.Checked:=True;
   2:RadioButton10.Checked:=True;
   end;
   if Russian_Interface then RadioButton6.Checked:=True
   else RadioButton7.Checked:=True;
   CheckBox29.Checked := FIDO_Descriptor_Enabled;
   CheckBox42.Checked := FIDO_Descriptor_KillOnNothing;
   CheckBox41.Checked := FIDO_Descriptor_KillOnExit;
   CheckBox43.Checked := FIDO_Descriptor_WinEnc;
   Edit6.Text := FIDO_Descriptor_Prefix;
   Edit7.Text := FIDO_Descriptor_Suffix;
   Edit8.Text := FIDO_Descriptor_Nothing;
   Edit5.Text := FIDO_Descriptor_Filename;
   Label1.Color := PLColorBk;
   Label1.Font.Color := PLColor;
   Label12.Color := PLColorBk;
   Label12.Font.Color := PLColor;
   Label13.Color := PLColorBkSel;
   Label13.Font.Color := PLColorSel;
   Label14.Color := PLColorBkSel;
   Label14.Font.Color := PLColorSel;
   Label15.Color := PLColorBkPl;
   Label15.Font.Color := PLColorPl;
   Label16.Color := PLColorBkPl;
   Label16.Font.Color := PLColorPl;
   Label17.Color := PLColorBkSel;
   Label17.Font.Color := PLColorPlSel;
   Label18.Color := PLColorBk;
   Label18.Font.Color := PLColorErr;
   Label19.Color := PLColorBkSel;
   Label19.Font.Color := PLColorErrSel;

   Edit9.Text:=IntToStr(VisTimerPeriod);

   GetSupportedEncodings(CBDefCP.Items);
   CBDefCP.Text:=CodePageDef;

   FillTools;
end;

procedure TForm6.CheckBox40Click(Sender: TObject);
begin
AutoSaveWindowsPos := CheckBox40.Checked;
end;

procedure TForm6.Button16Click(Sender: TObject);
begin
with Form1 do
 begin
  FIDO_Descriptor_Enabled := CheckBox29.Checked;
  FIDO_Descriptor_KillOnNothing := CheckBox42.Checked;
  FIDO_Descriptor_KillOnExit := CheckBox41.Checked;
  FIDO_Descriptor_WinEnc := CheckBox43.Checked;
  FIDO_Descriptor_Prefix := Edit6.Text;
  FIDO_Descriptor_Suffix := Edit7.Text;
  FIDO_Descriptor_Nothing := Edit8.Text;
  FIDO_Descriptor_Filename := Edit5.Text;
  FIDO_Descriptor_String := '';
  if IsPlaying and not Paused then
   FIDO_SaveStatus(FIDO_Playing)
  else
   FIDO_SaveStatus(FIDO_Nothing);
 end;
end;

procedure TIconSelector.ShowIcon;
var
  icon:TIcon;
begin
icon := TIcon.Create;
icon.LoadFromResourceName(hInstance,Format('ICON%.2u',[IconUpDown.Position]));

IcImg.Canvas.FillRect(IcImg.ClientRect);
IcImg.Canvas.Draw(0,0,icon);

AuthName.Caption := IconAuthors[IconUpDown.Position];

icon.Free;
end;

procedure TIconSelector.IconUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
ShowIcon;
DoSelectIcon(IconUpDown.Position);
end;

constructor TIconSelector.Create(AOwner:TWinControl);
begin
inherited Create;
IcGrp := TGroupBox.Create(AOwner);
IcGrp.Width := 97;
IcGrp.Height := 81;
IcImg := TImage.Create(IcGrp);
IcImg.Parent := IcGrp;
IcImg.Width := 32;
IcImg.Height := 32;
IcImg.Top := 1;
IcImg.Left := 24;
IconUpDown := TUpDown.Create(IcGrp);
IconUpDown.Parent := IcGrp;
IconUpDown.Height := 32;
IconUpDown.Top := 1;
IconUpDown.Left := 56;
IconUpDown.Max := NOfIcons;
IconUpDown.OnClick := @IconUpDownClick;
AuthLB := TLabel.Create(IcGrp);
AuthLB.Parent := IcGrp;
AuthLB.Left := 28;
AuthLB.Top := 33;
AuthLB.Caption := 'Author:';
AuthName := TLabel.Create(IcGrp);
AuthName.Parent := IcGrp;
AuthName.Alignment := taCenter;
AuthName.AutoSize := False;
AuthName.Left := 2;
AuthName.Top := 49;
AuthName.Width := 90;
IcGrp.Parent := AOwner;
end;

destructor TIconSelector.Destroy;
begin
try
 AuthName.Free;
 AuthLB.Free;
 IconUpDown.Free;
 IcImg.Free;
 IcGrp.Free;
finally
 inherited;
end;
end;

procedure TForm6.Button8Click(Sender: TObject);
begin
{$IFDEF Windows}
RegisterGroup(RegAudio,0,ListBox1,True);
RegisterGroup(RegBASS,3,ListBox2,True);
RegisterGroup(RegPlaylist,1,ListBox3,True);
RegisterGroup(RegSkin,2,ListBox4,True)
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.Button9Click(Sender: TObject);
{$IFDEF Windows}

 procedure UnCheck(i,t:integer;lb:TListBox);
 begin
 lb.Selected[i] := UnRegisterFile(PChar(LowerCase(lb.Items[i])),t)
 end;

var
 i:integer;
begin
for i := 0 to ListBox1.Count - 1 do
 UnCheck(i,0,ListBox1);
for i := 0 to ListBox2.Count - 1 do
 UnCheck(i,3,ListBox2);
for i := 0 to ListBox3.Count - 1 do
 UnCheck(i,1,ListBox3);
for i := 0 to ListBox4.Count - 1 do
 UnCheck(i,2,ListBox4);
{$ELSE Windows}
begin
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.SelectMusIcon(n:integer);
begin
if MusIconNumber <> n then
 begin
  MusIconNumber := n;
{$IFDEF Windows}
  RegisterType(0);
{$ENDIF Windows}
 end;
end;

procedure TForm6.SelectSkinIcon(n:integer);
begin
if SkinIconNumber <> n then
 begin
  SkinIconNumber := n;
{$IFDEF Windows}
  RegisterType(2);
{$ENDIF Windows}
 end;
end;

procedure TForm6.SelectListIcon(n:integer);
begin
if ListIconNumber <> n then
 begin
  ListIconNumber := n;
{$IFDEF Windows}
  RegisterType(1);
{$ENDIF Windows}
 end;
end;

procedure TForm6.SelectBASSIcon(n:integer);
begin
if BASSIconNumber <> n then
 begin
  BASSIconNumber := n;
{$IFDEF Windows}
  RegisterType(3)
{$ENDIF Windows}
 end
end;

function TForm6.ChangePLColor(var WantedColor:TColor):boolean;
begin
ColorDialog1.Color := WantedColor;
Result := ColorDialog1.Execute;
if Result then
 begin
  WantedColor := ColorDialog1.Color;
  RedrawPlaylist(ShownFrom,False);
 end;
end;

procedure TForm6.Label1Click(Sender: TObject);
begin
if ChangePLColor(PLColor) then
 begin
  Label1.Font.Color := PLColor;
  Label12.Font.Color := PLColor
 end
end;

procedure TForm6.Label12Click(Sender: TObject);
begin
if ChangePLColor(PLColorBk) then
 begin
  Label1.Color := PLColorBk;
  Label12.Color := PLColorBk;
  Label18.Color := PLColorBk
 end
end;

procedure TForm6.Label13Click(Sender: TObject);
begin
if ChangePLColor(PLColorSel) then
 begin
  Label13.Font.Color := PLColorSel;
  Label14.Font.Color := PLColorSel
 end
end;

procedure TForm6.Label14Click(Sender: TObject);
begin
if ChangePLColor(PLColorBkSel) then
 begin
  Label13.Color := PLColorBkSel;
  Label14.Color := PLColorBkSel;
  Label17.Color := PLColorBkSel;
  Label19.Color := PLColorBkSel;
 end;
end;

procedure TForm6.Label15Click(Sender: TObject);
begin
if ChangePLColor(PLColorPl) then
 begin
  Label15.Font.Color := PLColorPl;
  Label16.Font.Color := PLColorPl;
 end;
end;

procedure TForm6.Label16Click(Sender: TObject);
begin
if ChangePLColor(PLColorBkPl) then
 begin
  Label15.Color := PLColorBkPl;
  Label16.Color := PLColorBkPl;
 end;
end;

procedure TForm6.Label17Click(Sender: TObject);
begin
if ChangePLColor(PLColorPlSel) then Label17.Font.Color := PLColorPlSel;
end;

procedure TForm6.Label18Click(Sender: TObject);
begin
if ChangePLColor(PLColorErr) then Label18.Font.Color := PLColorErr;
end;

procedure TForm6.Label19Click(Sender: TObject);
begin
if ChangePLColor(PLColorErrSel) then Label19.Font.Color := PLColorErrSel;
end;

procedure TForm6.ListBox1Click(Sender: TObject);
begin
{$IFDEF Windows}
RegisterGroup(RegAudio,0,ListBox1,False);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.ListBox2Click(Sender: TObject);
begin
{$IFDEF Windows}
RegisterGroup(RegBASS,3,ListBox2,False);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.ListBox3Click(Sender: TObject);
begin
{$IFDEF Windows}
RegisterGroup(RegPlaylist,1,ListBox3,False);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

procedure TForm6.ListBox4Click(Sender: TObject);
begin
{$IFDEF Windows}
RegisterGroup(RegSkin,2,ListBox4,False);
{$ELSE Windows}
NonWin;
{$ENDIF Windows}
end;

{$IFDEF Windows}
procedure TForm6.RegisterGroup(rt:boolean;t:integer;lb:TListBox;All:boolean);
var
 s:string;
 i:integer;
begin
if not rt then RegisterType(t);
for i := 0 to lb.Count - 1 do
 begin
  s := LowerCase(lb.Items[i]);
  if lb.Selected[i] then
   begin
    if All or not CheckRegistration(PChar(s),t) then RegisterFile(PChar(s),t);
   end
  else
   if All or CheckRegistration(PChar(s),t) then UnRegisterFile(PChar(s),t);
 end;
end;
{$ENDIF Windows}

procedure TForm6.Button5Click(Sender: TObject);
var
 lb:TListBox;
 i:integer;
begin
case (Sender as TButton).Tag of
0:lb := ListBox1;
1:lb := ListBox2;
2:lb := ListBox3;
3:lb := ListBox4;
else exit;
end;
if lb.SelCount < lb.Count then
 lb.SelectAll
else
 for i := 0 to lb.Count - 1 do
  lb.Selected[i] := False;
lb.OnClick(Sender);
end;

procedure TForm6.EditVTPathChange(Sender: TObject);
begin
VTPath := EditVTPath.Text;
end;

procedure TForm6.FillTools;
begin
//if ButTools.Is_On then
 begin
 if not Russian_Interface then
  begin
  Caption := Lan_Tools_BoxTitle_En;
  GroupBox1.Caption := Lan_Tools_ConvParam_En;
  SearchTool.Caption := Lan_Tools_Searching_En;
  GroupBox3.Caption := Lan_Tools_SearchFor_En;
  GroupBox5.Caption := Lan_Tools_Prior_En;
  FTypTools.Caption := Lan_Tools_FilesReg_En;
  GroupBox10.Caption := Lan_Tools_StartMenu_En;
  GroupBox11.Caption := Lan_Tools_Tray_En;
  GroupBox12.Caption := Lan_Tools_SkTit_En;
  GroupBox13.Caption := Lan_Tools_DefDir_En;
  Label3.Caption := Lan_Tools_SourceFls_En;
  Label4.Caption := Lan_Tools_WorkFold_En;
  Label5.Caption := Lan_Tools_WorkRep_En;
  Label5.Caption := Lan_Tools_WorkRep_En;
  Label6.Caption := Lan_Tools_SkAut_En;
  Label7.Caption := Lan_Tools_SkCom_En;
  Label8.Caption := Lan_Tools_SkFN_En;
  RadioButton3.Caption := Lan_Tools_Idle_En;
  RadioButton4.Caption := Lan_Tools_Normal_En;
  RadioButton5.Caption := Lan_Tools_High_En;
  RadioButton8.Caption := Lan_Tools_Never_En;
  RadioButton9.Caption := Lan_Tools_Always_En;
  RadioButton10.Caption := Lan_Tools_Minim_En;
  Button1.Caption := Lan_Tools_Choose_En;
  Button2.Caption := Lan_Tools_Choose_En;
  Button3.Caption := Lan_Tools_Begin_En;
  Button7.Caption := Lan_Tools_RemoveEmu_En;
  Button8.Caption := Lan_Tools_Rereg_En;
  Button16.Caption := Lan_Tools_Apply_En;
  Button9.Caption := Lan_Tools_Restore_En;
  Button10.Caption := Lan_Tools_Add_En;
  Button11.Caption := Lan_Tools_Remove_En;
  Button12.Caption := Lan_Tools_Choose_En;
  Button13.Caption := Lan_Tools_SkStd_En;
  Button14.Caption := Lan_Tools_Save_En;
  CheckBox38.Caption := Lan_Tools_AutoSave_En
  end
 else
  begin
  Caption := Lan_Tools_BoxTitle_Ru;
  GroupBox1.Caption := Lan_Tools_ConvParam_Ru;
  SearchTool.Caption := Lan_Tools_Searching_Ru;
  GroupBox3.Caption := Lan_Tools_SearchFor_Ru;
  GroupBox5.Caption := Lan_Tools_Prior_Ru;
  FTypTools.Caption := Lan_Tools_FilesReg_Ru;
  GroupBox10.Caption := Lan_Tools_StartMenu_Ru;
  GroupBox11.Caption := Lan_Tools_Tray_Ru;
  GroupBox12.Caption := Lan_Tools_SkTit_Ru;
  GroupBox13.Caption := Lan_Tools_DefDir_Ru;
  Label3.Caption := Lan_Tools_SourceFls_Ru;
  Label4.Caption := Lan_Tools_WorkFold_Ru;
  Label5.Caption := Lan_Tools_WorkRep_Ru;
  Label6.Caption := Lan_Tools_SkAut_Ru;
  Label7.Caption := Lan_Tools_SkCom_Ru;
  Label8.Caption := Lan_Tools_SkFN_Ru;
  RadioButton3.Caption := Lan_Tools_Idle_Ru;
  RadioButton4.Caption := Lan_Tools_Normal_Ru;
  RadioButton5.Caption := Lan_Tools_High_Ru;
  RadioButton8.Caption := Lan_Tools_Never_Ru;
  RadioButton9.Caption := Lan_Tools_Always_Ru;
  RadioButton10.Caption := Lan_Tools_Minim_Ru;
  Button1.Caption := Lan_Tools_Choose_Ru;
  Button2.Caption := Lan_Tools_Choose_Ru;
  Button3.Caption := Lan_Tools_Begin_Ru;
  Button7.Caption := Lan_Tools_RemoveEmu_Ru;
  Button8.Caption := Lan_Tools_Rereg_Ru;
  Button16.Caption := Lan_Tools_Apply_Ru;
  Button9.Caption := Lan_Tools_Restore_Ru;
  Button10.Caption := Lan_Tools_Add_Ru;
  Button11.Caption := Lan_Tools_Remove_Ru;
  Button12.Caption := Lan_Tools_Choose_Ru;
  Button13.Caption := Lan_Tools_SkStd_Ru;
  Button14.Caption := Lan_Tools_Save_Ru;
  CheckBox38.Caption := Lan_Tools_AutoSave_Ru
  end;
  Button4.Caption := Form2.Button2.Caption;

 //Mask Lazarus Error
 //исчезает Vis period в Windows версии, помогает смена страниц PageControl1
 //или вот это:
 {$IFDEF Windows}
 Label20.Invalidate;
 {$ENDIF Windows}
 end;
end;

end.
